package widebase.plant

import net.liftweb.common. { Loggable, Logger }

class Main extends xsbti.AppMain with Logger with Loggable {

	protected class Exit(val code: Int) extends xsbti.Exit

	def run(configuration: xsbti.AppConfiguration) = {

    // Needed: https://github.com/harrah/xsbt/issues/435#issuecomment-6681951
    Thread.currentThread.setContextClassLoader(getClass.getClassLoader)

    Main.main(configuration.arguments)

    new Exit(0)

	}
}

object Main extends Logger with Loggable {

  import widebase.stream.socket.rq

  def main(args: Array[String]) {

    val broker = rq.broker

    var i = 0

    while(i < args.size) {

      args(i) match {

        case "-a" =>
          i += 1
          broker.load(args(i))

        case "-f" =>
          i += 1
          broker.filter(args(i))

        case "-i" =>
          i += 1
          broker.interval = args(i).toInt

        case "-p" =>
          i += 1
          broker.port = args(i).toInt

        case path: String =>
          broker.path = path

        case _ =>
          error("Unfamiliar with argument: " + args(i))
          sys.exit(1)

      }

      i += 1

    }

    try {

      broker.bind

      info("Listen on " + broker.port)

      broker.await

    } finally {

      broker.close

    }
  }
}

